diff --git a/web/pgadmin/misc/file_manager/static/js/utility.js b/web/pgadmin/misc/file_manager/static/js/utility.js
index d433b8e2..74ae4e40 100755
--- a/web/pgadmin/misc/file_manager/static/js/utility.js
+++ b/web/pgadmin/misc/file_manager/static/js/utility.js
@@ -10,1341 +10,1280 @@
  */
 import loading_icon from 'acitree/image/load-root.gif';
 
-define(['jquery', 'underscore', 'underscore.string',
-  'pgadmin.alertifyjs', 'sources/gettext',
-  'sources/url_for', 'dropzone'
-  ],
-function($, _, S, alertify, gettext, url_for, Dropzone) {
-
-/*---------------------------------------------------------
-  Define functions used for various operations
----------------------------------------------------------*/
-
-// return file extension
-var getFileExtension = function(name) {
-  var found = name.lastIndexOf('.') + 1;
-  return (found > 0 ? name.substr(found) : "");
-};
-
-// returns filename without extension
-var getFileName = function(name) {
-  var fm_filename = name;
-  if (fm_filename.length > 15 ) {
-    fm_filename = name.substr(0, 10) +'...';
-  }
-  return fm_filename;
-};
-
-/* Common function to load:
- * en.js language file
- * file_manager_config.js config file
- * return transaction id
- */
-var loadData = function(url) {
-  return $.ajax({
-    async: false,
-    cache: false,
-    url: url,
-    dataType: 'jsonp',
-    contentType: "application/json; charset=utf-8"
-  });
-};
-
-// Set enable/disable state of list and grid view
-var setViewButtonsFor = function(viewMode) {
-  if (viewMode == 'grid') {
+define([
+  'jquery', 'underscore', 'underscore.string', 'pgadmin.alertifyjs',
+  'sources/gettext', 'sources/url_for', 'dropzone', 'sources/pgadmin',
+], function($, _, S, Alertify, gettext, url_for, Dropzone, pgAdmin) {
+
+  /*---------------------------------------------------------
+    Define functions used for various operations
+  ---------------------------------------------------------*/
+
+  // Return file extension
+  var getFileExtension = function(name) {
+    var found = name.lastIndexOf('.') + 1;
+    return (found > 0 ? name.substr(found) : '');
+  };
+
+  /* Common function to load:
+   * en.js language file
+   * file_manager_config.js config file
+   * return transaction id
+   */
+  var loadData = function(url) {
+    return $.ajax({
+      async: false,
+      cache: false,
+      url: url,
+      dataType: 'jsonp',
+      contentType: 'application/json; charset=utf-8',
+    });
+  };
+
+  // Set enable/disable state of list and grid view
+  var setViewButtonsFor = function(viewMode) {
+    if (viewMode == 'grid') {
       $('.grid').addClass('ON');
       $('.list').removeClass('ON');
-  } else {
+    } else {
       $('.list').addClass('ON');
       $('.grid').removeClass('ON');
-  }
-};
-
-var save_file_dialog_view = function(view, trans_id) {
-  return $.ajax({
-    url: url_for('file_manager.save_file_dialog_view', {'trans_id': trans_id}),
-    type: 'POST',
-    async: true,
-    data: JSON.stringify({'view':view}),
-    contentType: 'application/json'
-  });
-};
-
-var save_show_hidden_file_option = function(option, trans_id) {
-  return $.ajax({
-    url: url_for('file_manager.save_show_hidden_file_option', {'trans_id': trans_id}),
-    type: 'PUT',
-    async: true,
-    data: JSON.stringify({'show_hidden': option}),
-    contentType: 'application/json'
-  });
-};
-
-
-/*
- * preg_replace
- */
-var preg_replace = function(array_pattern, array_pattern_replace, str)  {
-  var i = 0, reg_exp, val_to_replace,
-      new_str = String(str);
-
-  while (i < array_pattern.length) {
-    reg_exp= RegExp(array_pattern[i], "g");
-    val_to_replace = array_pattern_replace[i];
-
-    new_str = new_str.replace (reg_exp, val_to_replace);
-    i += 1;
-  }
-
-  return new_str;
-};
-
- //nameFormat (), separate filename from extension
-var nameFormat = function(input) {
-  var filename = '';
-  if (input.lastIndexOf('.') != -1) {
-    filename  = input.substr(0, input.lastIndexOf('.'));
-    filename += '.' + input.split('.').pop();
-  } else {
-    filename = input;
-  }
-  return filename;
-};
-
-//Converts bytes to kb, mb, or gb as needed for display.
-var formatBytes = function(bytes) {
-  var n = parseFloat(bytes),
-      d = parseFloat(1024),
-      c = 0,
-      lg = pgAdmin.FileUtils.lg,
-      u = [lg.bytes,lg.kb,lg.mb,lg.gb];
+    }
+  };
+
+  var save_file_dialog_view = function(view, trans_id) {
+    return $.ajax({
+      url: url_for('file_manager.save_file_dialog_view', {
+        'trans_id': trans_id,
+      }),
+      type: 'POST',
+      async: true,
+      data: JSON.stringify({
+        'view': view,
+      }),
+      contentType: 'application/json',
+    });
+  };
 
-  while(true) {
-    if (n < d) {
-      return (Math.round(n * 100) / 100) + u[c];
+  var save_show_hidden_file_option = function(option, trans_id) {
+    return $.ajax({
+      url: url_for('file_manager.save_show_hidden_file_option', {
+        'trans_id': trans_id,
+      }),
+      type: 'PUT',
+      async: true,
+      data: JSON.stringify({
+        'show_hidden': option,
+      }),
+      contentType: 'application/json',
+    });
+  };
+
+  // nameFormat (), separate filename from extension
+  var nameFormat = function(input) {
+    var filename = '';
+    if (input.lastIndexOf('.') != -1) {
+      filename = input.substr(0, input.lastIndexOf('.'));
+      filename += '.' + input.split('.').pop();
+    } else {
+      filename = input;
     }
-    n /= d;
-    c += 1;
-  }
-};
-
-// Freeze toolbar buttons and display errors
-var handleError = function(errMsg) {
-  $('.storage_dialog .newfile').attr("disabled", "disabled");
-  $('.storage_dialog .upload').attr("disabled", "disabled");
-  $('.storage_dialog .create').attr("disabled", "disabled");
-};
-
-/*
- * Test if Data structure has the 'cap' capability
- * 'cap' is one of 'select', 'rename', 'delete', 'download'
- */
-var has_capability = function(data, cap) {
-  if (typeof(data.Capabilities) == "undefined") {
-    return true;
-  } else {
-    return ($.inArray(cap, data.Capabilities) > -1);
-  }
-};
-
-// return filename extension
-var getExtension = function(filename) {
-  if (filename.split('.').length == 1) {
-    return "";
-  }
-  return filename.split('.').pop();
-};
-
-// return filename without extension
-var getFilename = function(filename) {
-  if (filename.lastIndexOf('.') != -1) {
-    return filename.substring(0, filename.lastIndexOf('.'));
-  } else {
     return filename;
-  }
-};
+  };
 
-/*
- * Binds specific actions to the toolbar based on capability.
- * and show/hide buttons
- */
-var bindToolbar = function(data) {
+  /*
+   * Test if Data structure has the 'cap' capability
+   * 'cap' is one of 'select', 'rename', 'delete', 'download'
+   */
+  var has_capability = function(data, cap) {
+    if (typeof(data.Capabilities) == 'undefined') {
+      return true;
+    } else {
+      return ($.inArray(cap, data.Capabilities) > -1);
+    }
+  };
 
-  // hide/show rename, upload and create button
-  if(_.has(data, 'Capabilities')) {
-    _.each(data.Capabilities, function(cap) {
-      var target_btn = 'button.' + cap,
-          $target_el = $('.file_manager').find(target_btn);
-      if (!has_capability(data, cap) || pgAdmin.FileUtils.hideButtons()) {
-        $target_el.hide();
-      } else {
-        $target_el.show();
-      }
-    });
-  }
-
-  if (!has_capability(data, 'delete') || pgAdmin.FileUtils.hideButtons()) {
-    $('.file_manager').find('button.delete').hide();
-  } else {
-    $('.file_manager').find('button.delete').click(function() {
-      // hide dimmer
-      $('.fileinfo .delete_item, .fm_dimmer').show();
-    });
+  // return filename extension
+  var getExtension = function(filename) {
+    if (filename.split('.').length == 1) {
+      return '';
+    }
+    return filename.split('.').pop();
+  };
+
+  /*
+   * Binds specific actions to the toolbar based on capability.
+   * and show/hide buttons
+   */
+  var bindToolbar = function(data) {
 
-    // take action based on pressed button yes or no
-    $('.fileinfo .delete_item button.btn_yes').unbind().on('click', function() {
-      var path;
-      if ($('.fileinfo').data('view') == 'grid') {
-        path = decodeURI($('.fileinfo').find('#contents li.selected .clip span').attr('data-alt'));
-        if (path.lastIndexOf('/') == path.length - 1) {
-          data.Path = path;
-          deleteItem(data);
+    // hide/show rename, upload and create button
+    if (_.has(data, 'Capabilities')) {
+      _.each(data.Capabilities, function(cap) {
+        var target_btn = 'button.' + cap,
+          $target_el = $('.file_manager').find(target_btn);
+        if (!has_capability(data, cap) || pgAdmin.FileUtils.hideButtons()) {
+          $target_el.hide();
         } else {
-          deleteItem(data);
+          $target_el.show();
         }
-      } else {
-        path = $('.fileinfo').find('table#contents tbody tr.selected td:first-child').attr('title');
-        if (path.lastIndexOf('/') == path.length - 1) {
-          data.Path = path;
-          deleteItem(data);
+      });
+    }
+
+    if (!has_capability(data, 'delete') || pgAdmin.FileUtils.hideButtons()) {
+      $('.file_manager').find('button.delete').hide();
+    } else {
+      $('.file_manager').find('button.delete').click(function() {
+        // hide dimmer
+        $('.fileinfo .delete_item, .fm_dimmer').show();
+      });
+
+      // take action based on pressed button yes or no
+      $('.fileinfo .delete_item button.btn_yes').unbind().on('click', function() {
+        var path;
+        if ($('.fileinfo').data('view') == 'grid') {
+          path = decodeURI($('.fileinfo').find('#contents li.selected .clip span').attr('data-alt'));
+          if (path.lastIndexOf('/') == path.length - 1) {
+            data.Path = path;
+            deleteItem(data);
+          } else {
+            deleteItem(data);
+          }
         } else {
-          deleteItem(data);
+          path = $('.fileinfo').find('table#contents tbody tr.selected td:first-child').attr('title');
+          if (path.lastIndexOf('/') == path.length - 1) {
+            data.Path = path;
+            deleteItem(data);
+          } else {
+            deleteItem(data);
+          }
         }
-      }
-      // hide dimmer
-      $('.fileinfo .fm_dimmer').hide();
-    });
+        // hide dimmer
+        $('.fileinfo .fm_dimmer').hide();
+      });
 
-  }
-
-  // Download file on download button click
-  if (!has_capability(data, 'download') || pgAdmin.FileUtils.hideButtons()) {
-    $('.file_manager').find('button.download').hide();
-  } else {
-    $('.file_manager').find('button.download').unbind().click(function() {
-      var path;
-      if ($('.fileinfo').data('view') == 'grid') {
-        path = $('.fileinfo li.selected').find('.clip span').attr('data-alt');
-        window.open(pgAdmin.FileUtils.fileConnector + '?mode=download&path=' + path, '_blank');
-      } else {
-        path = $('.fileinfo').find('table#contents tbody tr.selected td:first-child').attr('title');
-        window.open(pgAdmin.FileUtils.fileConnector + '?mode=download&path=' + path, '_blank');
-      }
-    });
-  }
-};
-
-// enable/disable button when files/folder are loaded
-var enable_disable_btn = function() {
-  if ($('.fileinfo').data('view') == 'grid') {
-    var $grid_file = $('.file_manager').find('#contents li.selected');
-    $grid_file.removeClass('selected');
-    $('.file_manager').find('button.delete').prop('disabled', true);
-    $('.file_manager').find('button.download').prop('disabled', true);
-    $('.file_manager').find('button.rename').prop('disabled', true);
-    if ($grid_file.length > 0) {
-      $('.file_manager_ok').addClass('disabled');
-      $('.file_manager_ok').attr('disabled', true);
     }
-  } else {
-    var $list_file = $('.fileinfo').find('table#contents tbody tr.selected');
-    $list_file.removeClass('selected');
-    $('.file_manager').find('button.delete').prop('disabled', true);
-    $('.file_manager').find('button.download').prop('disabled', true);
-    $('.file_manager').find('button.rename').prop('disabled', true);
-    if ($list_file.length > 0) {
-      $('.file_manager_ok').addClass('disabled');
-      $('.file_manager_ok').attr('disabled', true);
+
+    // Download file on download button click
+    if (!has_capability(data, 'download') || pgAdmin.FileUtils.hideButtons()) {
+      $('.file_manager').find('button.download').hide();
+    } else {
+      $('.file_manager').find('button.download').unbind().click(function() {
+        var path;
+        if ($('.fileinfo').data('view') == 'grid') {
+          path = $('.fileinfo li.selected').find('.clip span').attr('data-alt');
+          window.open(pgAdmin.FileUtils.fileConnector + '?_=' + Date.now() + 'mode=download&path=' + path, '_blank');
+        } else {
+          path = $('.fileinfo').find('table#contents tbody tr.selected td:first-child').attr('title');
+          window.open(pgAdmin.FileUtils.fileConnector + '?_=' + Date.now() + 'mode=download&path=' + path, '_blank');
+        }
+      });
     }
-  }
-
-  $('.delete_item').hide();
-  // clear address bar
-  $('.file_manager #uploader .input-path').show();
-  $('.file_manager #uploader .show_selected_file').remove();
-};
-
-/*
- * Rename the current item and returns the new name.
- * by double clicking or by clicking the "Rename" button in
- * table(list) views.
- */
-var renameItem = function(data) {
-  var orig_name = getFilename(data.Filename),
-      finalName = '',
-      lg = pgAdmin.FileUtils.lg;
+  };
 
-  var getNewName = function(rname) {
-    if (rname !== '') {
-      var givenName = nameFormat(rname),
-          suffix = getExtension(data.Filename);
-      if (suffix.length > 0) {
-        givenName = givenName + '.' + suffix;
+  // enable/disable button when files/folder are loaded
+  var enable_disable_btn = function() {
+    if ($('.fileinfo').data('view') == 'grid') {
+      var $grid_file = $('.file_manager').find('#contents li.selected');
+      $grid_file.removeClass('selected');
+      $('.file_manager').find('button.delete').prop('disabled', true);
+      $('.file_manager').find('button.download').prop('disabled', true);
+      $('.file_manager').find('button.rename').prop('disabled', true);
+      if ($grid_file.length > 0) {
+        $('.file_manager_ok').addClass('disabled');
+        $('.file_manager_ok').attr('disabled', true);
       }
+    } else {
+      var $list_file = $('.fileinfo').find('table#contents tbody tr.selected');
+      $list_file.removeClass('selected');
+      $('.file_manager').find('button.delete').prop('disabled', true);
+      $('.file_manager').find('button.download').prop('disabled', true);
+      $('.file_manager').find('button.rename').prop('disabled', true);
+      if ($list_file.length > 0) {
+        $('.file_manager_ok').addClass('disabled');
+        $('.file_manager_ok').attr('disabled', true);
+      }
+    }
 
-      var oldPath = data.Path,
-          post_data = {
-            "mode": "rename",
-            "old": data.Path,
-            "new": givenName
-          };
+    $('.delete_item').hide();
+    // clear address bar
+    $('.file_manager #uploader .input-path').show();
+    $('.file_manager #uploader .show_selected_file').remove();
+  };
+
+  /*
+   * Rename the current item and returns the new name.
+   * by double clicking or by clicking the "Rename" button in
+   * table(list) views.
+   */
+  var renameItem = function(data) {
+    var finalName = '',
+      lg = pgAdmin.FileUtils.lg,
+      getNewName = function(rname) {
+        if (rname !== '') {
+          var givenName = nameFormat(rname),
+            suffix = getExtension(data.Filename);
+          if (suffix.length > 0) {
+            givenName = givenName + '.' + suffix;
+          }
+
+          var oldPath = data.Path,
+            post_data = {
+              'mode': 'rename',
+              'old': data.Path,
+              'new': givenName,
+            };
+
+          $.ajax({
+            type: 'POST',
+            data: JSON.stringify(post_data),
+            url: pgAdmin.FileUtils.fileConnector,
+            dataType: 'json',
+            contentType: 'application/json; charset=utf-8',
+            async: false,
+            success: function(resp) {
+              var result = resp.data.result;
+              if (result.Code === 1) {
+                var newPath = result['New Path'],
+                  newName = result['New Name'],
+                  title = $('#preview h1').attr('title');
+
+                if (typeof title != 'undefined' && title == oldPath) {
+                  $('#preview h1').text(newName);
+                }
+
+                if ($('.fileinfo').data('view') == 'grid') {
+                  $('.fileinfo span[data-alt="' + oldPath + '"]').parent().next('p span').text(newName);
+                  $('.fileinfo span[data-alt="' + oldPath + '"]').attr('data-alt', newPath);
+                } else {
+                  $('.fileinfo td[title="' + oldPath + '"]').text(newName);
+                  $('.fileinfo td[title="' + oldPath + '"]').attr('title', newPath);
+                }
+                $('#preview h1').html(newName);
+
+                // actualized data for binding
+                data.Path = newPath;
+                data.Filename = newName;
+
+                // UnBind toolbar functions.
+                $('.fileinfo').find('button.rename, button.delete, button.download').unbind();
+
+                Alertify.success(lg.successful_rename);
+              } else {
+                Alertify.error(result.Error);
+              }
+
+              finalName = result['New Name'];
+            },
+          });
+        }
+      };
+
+    getNewName(data.NewFilename);
+    return finalName;
+  };
+
+  /*
+   * delete the folder or files by clicking the "Delete" button
+   * in table(list) view
+   */
+  var deleteItem = function(data) {
+    var isDeleted = false,
+      lg = pgAdmin.FileUtils.lg;
+
+    var doDelete = function(data) {
+      var post_data = {
+        'mode': 'delete',
+        'path': data.Path,
+      };
 
       $.ajax({
         type: 'POST',
         data: JSON.stringify(post_data),
         url: pgAdmin.FileUtils.fileConnector,
         dataType: 'json',
-        contentType: "application/json; charset=utf-8",
+        contentType: 'application/json; charset=utf-8',
         async: false,
         success: function(resp) {
           var result = resp.data.result;
           if (result.Code === 1) {
-            var newPath = result['New Path'],
-                newName = result['New Name'],
-                title = $("#preview h1").attr("title");
-
-            if (typeof title !="undefined" && title == oldPath) {
-              $('#preview h1').text(newName);
+            isDeleted = true;
+            if (isDeleted) {
+              Alertify.success(lg.successful_delete);
+              var rootpath = result.Path.substring(0, result.Path.length - 1); // removing the last slash
+              rootpath = rootpath.substr(0, rootpath.lastIndexOf('/') + 1);
+              getFolderInfo(rootpath);
             }
-
-            if ($('.fileinfo').data('view') == 'grid') {
-              $('.fileinfo span[data-alt="' + oldPath + '"]').parent().next('p span').text(newName);
-              $('.fileinfo span[data-alt="' + oldPath + '"]').attr('data-alt', newPath);
-            } else {
-              $('.fileinfo td[title="' + oldPath + '"]').text(newName);
-              $('.fileinfo td[title="' + oldPath + '"]').attr('title', newPath);
-            }
-            $("#preview h1").html(newName);
-
-            // actualized data for binding
-            data.Path=newPath;
-            data.Filename=newName;
-
-            // UnBind toolbar functions.
-            $('.fileinfo').find('button.rename, button.delete, button.download').unbind();
-
-            alertify.success(lg.successful_rename);
           } else {
-            alertify.error(result.Error);
+            isDeleted = false;
+            Alertify.error(result.Error);
           }
-
-          finalName = result['New Name'];
-        }
+        },
       });
-    }
-  };
-
-  getNewName(data.NewFilename);
-  return finalName;
-};
+      return isDeleted;
+    };
 
-/*
- * delete the folder or files by clicking the "Delete" button
- * in table(list) view
- */
-var deleteItem = function(data) {
-  var isDeleted = false,
-      lg = pgAdmin.FileUtils.lg,
-      msg = lg.confirmation_delete;
+    doDelete(data);
+    return isDeleted;
+  };
 
-  var doDelete = function(data) {
-    var parent = data.Path.split('/').reverse().slice(1).reverse().join('/') + '/';
-    var post_data = {
-          "mode": "delete",
-          "path": data.Path
-        };
+  /*---------------------------------------------------------
+    Functions to Retrieve File and Folder Details
+  ---------------------------------------------------------*/
+  /*
+   * Retrieves information about the specified file as a JSON
+   * object and uses that data to populate a template for
+   * list views. Binds the toolbar for that file/folder to
+   * enable specific actions. Called whenever an item is
+   * clicked in list views.
+   */
+  var getFileInfo = function(file) {
+    // Update location for status, upload, & new folder functions.
+    pgAdmin.FileUtils.setUploader(file);
+    var capabilities = pgAdmin.FileUtils.data.capabilities,
+      is_file_valid = false,
+      post_data = {
+        'path': file,
+        'mode': 'getinfo',
+      };
 
+    // Retrieve the data & populate the template.
     $.ajax({
       type: 'POST',
       data: JSON.stringify(post_data),
       url: pgAdmin.FileUtils.fileConnector,
       dataType: 'json',
-      contentType: "application/json; charset=utf-8",
+      contentType: 'application/json; charset=utf-8',
       async: false,
       success: function(resp) {
-        var result = resp.data.result;
-        if (result.Code === 1) {
-          isDeleted = true;
-          if (isDeleted) {
-            alertify.success(lg.successful_delete);
-            var rootpath = result.Path.substring(0, result.Path.length-1); // removing the last slash
-                rootpath = rootpath.substr(0, rootpath.lastIndexOf('/') + 1);
-            getFolderInfo(rootpath);
+        var data = resp.data.result;
+        if (data.Code === 1) {
+          $('.file_manager_ok').removeClass('disabled');
+          $('.file_manager_ok').attr('disabled', false);
+          data.Capabilities = capabilities;
+          bindToolbar(data);
+          if (data.FileType == 'Directory') {
+            // Enable/Disable level up button
+            enab_dis_level_up();
+            $('.file_manager_ok').addClass('disabled');
+            $('.file_manager_ok').attr('disabled', true);
+            $('.file_manager button.delete, .file_manager button.rename').attr('disabled', 'disabled');
+            $('.file_manager button.download').attr('disabled', 'disabled');
+
+            if (file.charAt(file.length - 1) != '/' && file.charAt(file.length - 1) != '\\') {
+              file += '/';
+            }
+            getFolderInfo(file);
+          } else {
+            is_file_valid = true;
           }
         } else {
-          isDeleted = false;
-          alertify.error(result.Error);
+          $('.file_manager_ok').addClass('disabled');
+          $('.file_manager_ok').attr('disabled', true);
+          Alertify.error(data.Error);
         }
-      }
+      },
     });
-    return isDeleted;
+    return is_file_valid;
   };
 
-  doDelete(data);
-  return isDeleted;
-};
-
-/*---------------------------------------------------------
-  Functions to Retrieve File and Folder Details
----------------------------------------------------------*/
-/*
- * Retrieves information about the specified file as a JSON
- * object and uses that data to populate a template for
- * list views. Binds the toolbar for that file/folder to
- * enable specific actions. Called whenever an item is
- * clicked in list views.
- */
-var getFileInfo = function(file) {
-  // Update location for status, upload, & new folder functions.
-  pgAdmin.FileUtils.setUploader(file);
-  var capabilities = pgAdmin.FileUtils.data.capabilities;
-
-  // Retrieve the data & populate the template.
-  var d = new Date(), // to prevent IE cache issues
-    is_file_valid =  false;
-  var post_data = {
-    'path': file,
-    'mode': 'getinfo'
-  };
-  var lg = pgAdmin.FileUtils.lg;
-
-  $.ajax({
-    type: 'POST',
-    data: JSON.stringify(post_data),
-    url: pgAdmin.FileUtils.fileConnector,
-    dataType: 'json',
-    contentType: "application/json; charset=utf-8",
-    async: false,
-    success: function(resp) {
-      var data = resp.data.result;
-      if (data.Code === 1) {
-        $('.file_manager_ok').removeClass('disabled');
-        $('.file_manager_ok').attr('disabled', false);
-        var properties = '';
-        if (
-          data.Properties.Size || parseInt(data.Properties.Size)==0
-        ) {
-          properties += '<dt>' + lg.size + '</dt><dd>' + formatBytes(
-            data.Properties.Size
-          ) + '</dd>';
-        }
-        data.Capabilities = capabilities;
-        bindToolbar(data);
-        if (data.FileType == 'Directory') {
-          // Enable/Disable level up button
-          enab_dis_level_up();
-          $('.file_manager_ok').addClass('disabled');
-          $('.file_manager_ok').attr('disabled', true);
-          $('.file_manager button.delete, .file_manager button.rename').attr('disabled', 'disabled');
-          $('.file_manager button.download').attr('disabled', 'disabled');
+  var checkPermission = function(path) {
+    var permission = false,
+      post_data = {
+        'path': path,
+        'mode': 'permission',
+      };
 
-          if (file.charAt(file.length - 1) != '/' && file.charAt(file.length - 1) != '\\') {
-            file += '/';
-          }
-          getFolderInfo(file);
+    $.ajax({
+      type: 'POST',
+      data: JSON.stringify(post_data),
+      url: pgAdmin.FileUtils.fileConnector,
+      dataType: 'json',
+      contentType: 'application/json; charset=utf-8',
+      async: false,
+      success: function(resp) {
+        var data = resp.data.result;
+        if (data.Code === 1) {
+          permission = true;
         } else {
-          is_file_valid = true;
+          $('.file_manager_ok').addClass('disabled');
+          $('.file_manager_ok').attr('disabled', true);
+          Alertify.error(data.Error);
         }
-      } else {
+      },
+      error: function() {
         $('.file_manager_ok').addClass('disabled');
         $('.file_manager_ok').attr('disabled', true);
-        alertify.error(data.Error);
-      }
-    }
-  });
-  return is_file_valid;
-};
+        Alertify.error(
+          gettext('Error occurred while checking access permission.')
+        );
+      },
+    });
+    return permission;
+  };
 
-var checkPermission = function(path) {
-  var permission = false,
-      post_data = {
-        'path': path,
-        'mode': 'permission'
-      };
 
-  $.ajax({
-    type: 'POST',
-    data: JSON.stringify(post_data),
-    url: pgAdmin.FileUtils.fileConnector,
-    dataType: 'json',
-    contentType: "application/json; charset=utf-8",
-    async: false,
-    success: function(resp) {
-      var data = resp.data.result;
-      if (data.Code === 1) {
-        permission = true;
-      } else {
-        $('.file_manager_ok').addClass('disabled');
-        $('.file_manager_ok').attr('disabled', true);
-        alertify.error(data.Error);
-      }
-    },
-    error: function() {
-      $('.file_manager_ok').addClass('disabled');
-      $('.file_manager_ok').attr('disabled', true);
-      alertify.error( gettext('Error occurred while checking access permission.'));
-    }
-  });
-  return permission;
-};
 
+  /*
+   * Retrieves data for all items within the given folder and
+   * creates a list view.
+   */
+  var getFolderInfo = function(path, file_type) {
+    $('.storage_dialog #uploader .input-path').prop('disabled', true);
+    if (!file_type) {
+      file_type = '';
+    }
+    var capabilities = pgAdmin.FileUtils.data.Capabilities;
+    // Update location for status, upload, & new folder functions.
+    pgAdmin.FileUtils.setUploader(path);
 
+    // set default selected file type
+    if (file_type === '') {
+      file_type = $('.change_file_types select').val();
+    }
 
-/*
- * Retrieves data for all items within the given folder and
- * creates a list view.
- */
-var getFolderInfo = function(path, file_type) {
-  $('.storage_dialog #uploader .input-path').prop('disabled', true);
-  if (!file_type) {
-    file_type = '';
-  }
-  var capabilities = pgAdmin.FileUtils.data.Capabilities;
-  // Update location for status, upload, & new folder functions.
-  pgAdmin.FileUtils.setUploader(path);
-
-  // set default selected file type
-  if (file_type === '') {
-    file_type = $('.change_file_types select').val();
-  }
-
-  // navigate to directory or path when clicked on breadcrumbs
-  $('.file_manager a.breadcrumbs').unbind().on('click', function() {
-    var curr_path = $(this).attr('data-path'),
+    // navigate to directory or path when clicked on breadcrumbs
+    $('.file_manager a.breadcrumbs').unbind().on('click', function() {
+      var curr_path = $(this).attr('data-path'),
         current_dir = $(this).html(),
         move_to = curr_path.substring(
           0, curr_path.lastIndexOf(current_dir)
         ) + current_dir;
 
-    getFolderInfo(move_to);
-    enab_dis_level_up();
-  });
-
-   // hide select file if we are listing drives in windows.
-   if (pgAdmin.FileUtils.hideButtons()) {
-     $(".allowed_file_types .change_file_types").hide();
-   } else {
-     $(".allowed_file_types .change_file_types").show();
-   }
-
-  var loading_icon_url = url_for(
-    'static', {'filename': 'js/generated/' + loading_icon }
-  );
-
-  // Display an activity indicator.
-  $('.fileinfo').find('span.activity').html(
-    '<img src="' + loading_icon_url + '" alt="' + gettext("Loading...") + '"/>'
-  );
-
-  var post_data = {
-    'path': path,
-    'mode': 'getfolder',
-    'file_type': file_type || "*",
-    'show_hidden': $('#show_hidden').prop('checked')
-  };
+      getFolderInfo(move_to);
+      enab_dis_level_up();
+    });
 
-  var lg = pgAdmin.FileUtils.lg;
-  $.ajax({
-    type: 'POST',
-    data: JSON.stringify(post_data),
-    url: pgAdmin.FileUtils.fileConnector,
-    dataType: 'json',
-    contentType: "application/json; charset=utf-8",
-    async: false,
-    success: function(resp) {
-      $('.storage_dialog #uploader .input-path').prop('disabled', false);
-      var result = '',
-          data = resp.data.result;
+    // hide select file if we are listing drives in windows.
+    if (pgAdmin.FileUtils.hideButtons()) {
+      $('.allowed_file_types .change_file_types').hide();
+    } else {
+      $('.allowed_file_types .change_file_types').show();
+    }
 
-      // hide activity indicator
-      $('.fileinfo').find('span.activity').hide();
-      if (data.Code === 0) {
-        alertify.error(data.Error);
-        return;
+    var loading_icon_url = url_for(
+      'static', {
+        'filename': 'js/generated/' + loading_icon,
       }
-      // generate HTML for files/folder and render into container
-      if (!_.isEmpty(data)) {
-        if ($('.fileinfo').data('view') == 'grid') {
-          result += '<ul id="contents" class="grid">';
-          Object.keys(data).sort(function keyOrder(x, y) {
+    );
+
+    // Display an activity indicator.
+    $('.fileinfo').find('span.activity').html(
+      '<img src="' + loading_icon_url + '" alt="' + gettext('Loading...') + '/>'
+    );
+
+    var post_data = {
+      'path': path,
+      'mode': 'getfolder',
+      'file_type': file_type || '*',
+      'show_hidden': $('#show_hidden').prop('checked'),
+    };
+
+    var lg = pgAdmin.FileUtils.lg;
+    $.ajax({
+      type: 'POST',
+      data: JSON.stringify(post_data),
+      url: pgAdmin.FileUtils.fileConnector,
+      dataType: 'json',
+      contentType: 'application/json; charset=utf-8',
+      async: false,
+      success: function(resp) {
+        $('.storage_dialog #uploader .input-path').prop('disabled', false);
+        var result = '',
+          data = resp.data.result;
+
+        // hide activity indicator
+        $('.fileinfo').find('span.activity').hide();
+        if (data.Code === 0) {
+          Alertify.error(data.Error);
+          return;
+        }
+
+        var $this, orig_value, newvalue;
+
+        // generate HTML for files/folder and render into container
+        if (!_.isEmpty(data)) {
+          if ($('.fileinfo').data('view') == 'grid') {
+            result += '<ul id="contents" class="grid">';
+            Object.keys(data).sort(function keyOrder(x, y) {
               return pgAdmin.natural_sort(x.toLowerCase(), y.toLowerCase());
-            }).forEach(function (key) {
-            var props = (data[key]).Properties,
-                cap_classes = "";
+            }).forEach(function(key) {
+              var props = (data[key]).Properties,
+                cap_classes = '';
 
-            Object.keys(capabilities).forEach(function (cap) {
-              if (has_capability(data[key], capabilities[cap])) {
-                cap_classes += "cap_" + capabilities[cap];
-              }
-            });
+              Object.keys(capabilities).forEach(function(cap) {
+                if (has_capability(data[key], capabilities[cap])) {
+                  cap_classes += 'cap_' + capabilities[cap];
+                }
+              });
 
-            (data[key]).Capabilities = capabilities;
-            bindToolbar(data[key]);
+              (data[key]).Capabilities = capabilities;
+              bindToolbar(data[key]);
 
-            var class_type;
-            if ((data[key]).file_type == 'dir') {
-              class_type = 'fa fa-folder-open fm_folder';
-            } else if ((data[key]).file_type == 'drive') {
-              class_type = 'fa fa-hdd-o fm_drive';
-            } else {
-              class_type = 'fa fa-file-text fm_file';
-            }
+              var class_type;
+              if ((data[key]).file_type == 'dir') {
+                class_type = 'fa fa-folder-open fm_folder';
+              } else if ((data[key]).file_type == 'drive') {
+                class_type = 'fa fa-hdd-o fm_drive';
+              } else {
+                class_type = 'fa fa-file-text fm_file';
+              }
 
-            var fm_filename = (data[key]).Filename;
-            if (fm_filename.length > 15 ) {
-              fm_filename = (data[key]).Filename.substr(0, 10) +'...';
-            }
+              var fm_filename = (data[key]).Filename;
+              if (fm_filename.length > 15) {
+                fm_filename = (data[key]).Filename.substr(0, 10) + '...';
+              }
 
-            var file_name_original = encodeURI((data[key]).Filename);
-            var file_path_orig = encodeURI((data[key]).Path);
+              var file_name_original = encodeURI((data[key]).Filename);
+              var file_path_orig = encodeURI((data[key]).Path);
 
-            result += '<li class="' + cap_classes +
-              '"><div class="clip"><span data-alt="' +
+              result += '<li class="' + cap_classes +
+                '"><div class="clip"><span data-alt="' +
                 file_path_orig + '" class="' + class_type + '"></span>';
-            if ((data[key]).Protected == 1) {
-              result += '<span class="fa fa-lock fm_lock_icon" data-protected="protected"></span>';
-            }
+              if ((data[key]).Protected == 1) {
+                result += '<span class="fa fa-lock fm_lock_icon" data-protected="protected"></span>';
+              }
 
-            result += '</div>';
-            if (!has_capability(data[key], 'rename')) {
-              result += '<span>' + fm_filename + '</span>';
-            } else {
-              result +=
-                '<p><input type="text" class="fm_file_rename" />' +
-                '<span class="less_text" title="' + file_name_original+'">' + fm_filename +
-                '</span></p>';
-            }
-            if (props.Width && props.Width != '') {
-               result += '<span class="meta dimensions">' +
-                 props.Width + 'x' + props.Height + '</span>';
-            }
-            if (props.Size && props.Size != '') {
-              result += '<span class="meta size">' +
-                props.Size + '</span>';
-            }
-            if (props['Date Created'] && props['Date Created'] != '') {
-              result += '<span class="meta created">' +
-                props['Date Created'] + '</span>';
-            }
-            if (props['Date Modified'] && props['Date Modified'] != '') {
-              result += '<span class="meta modified">' +
-                props['Date Modified'] + '</span>';
-            }
-            result += '</li>';
-          });
+              result += '</div>';
+              if (!has_capability(data[key], 'rename')) {
+                result += '<span>' + fm_filename + '</span>';
+              } else {
+                result +=
+                  '<p><input type="text" class="fm_file_rename" />' +
+                  '<span class="less_text" title="' + file_name_original + '">' + fm_filename +
+                  '</span></p>';
+              }
+              if (props.Width && props.Width != '') {
+                result += '<span class="meta dimensions">' +
+                  props.Width + 'x' + props.Height + '</span>';
+              }
+              if (props.Size && props.Size != '') {
+                result += '<span class="meta size">' +
+                  props.Size + '</span>';
+              }
+              if (props['Date Created'] && props['Date Created'] != '') {
+                result += '<span class="meta created">' +
+                  props['Date Created'] + '</span>';
+              }
+              if (props['Date Modified'] && props['Date Modified'] != '') {
+                result += '<span class="meta modified">' +
+                  props['Date Modified'] + '</span>';
+              }
+              result += '</li>';
+            });
 
-          result += '</ul>';
-        } else {
-          result += '<table id="contents" class="list">';
-          result += '<thead><tr><th class="headerSortDown">';
-          result += '<span>' + lg.name +'</span></th>';
-          result += '<th><span>' + lg.size + '</span></th><th>';
-          result += '<span>' + lg.modified + '</span></th></tr></thead>';
-          result += '<tbody>';
-
-          Object.keys(data).sort(function keyOrder(x, y) {
+            result += '</ul>';
+          } else {
+            result += '<table id="contents" class="list">';
+            result += '<thead><tr><th class="headerSortDown">';
+            result += '<span>' + lg.name + '</span></th>';
+            result += '<th><span>' + lg.size + '</span></th><th>';
+            result += '<span>' + lg.modified + '</span></th></tr></thead>';
+            result += '<tbody>';
+
+            Object.keys(data).sort(function keyOrder(x, y) {
               return pgAdmin.natural_sort(x.toLowerCase(), y.toLowerCase());
-            }).forEach(function (key) {
-            var path = encodeURI((data[key]).Path),
+            }).forEach(function(key) {
+              var path = encodeURI((data[key]).Path),
                 props = (data[key]).Properties,
-                cap_classes = "", cap, class_type;
+                cap_classes = '',
+                cap, class_type;
 
-            for (cap in capabilities) {
-              if (has_capability(data[key], capabilities[cap])) {
-                cap_classes += " cap_" + capabilities[cap];
+              for (cap in capabilities) {
+                if (has_capability(data[key], capabilities[cap])) {
+                  cap_classes += ' cap_' + capabilities[cap];
+                }
               }
-            }
 
-            (data[key]).Capabilities = capabilities;
-            bindToolbar(data[key]);
+              (data[key]).Capabilities = capabilities;
+              bindToolbar(data[key]);
 
-            if ((data[key]).file_type == 'dir') {
-              class_type = 'fa fa-folder-open tbl_folder';
-            }
-            else if ((data[key]).file_type == 'drive') {
-              class_type = 'fa fa-hdd-o tbl_drive';
-            } else {
-              class_type = 'fa fa-file-text tbl_file';
-            }
+              if ((data[key]).file_type == 'dir') {
+                class_type = 'fa fa-folder-open tbl_folder';
+              } else if ((data[key]).file_type == 'drive') {
+                class_type = 'fa fa-hdd-o tbl_drive';
+              } else {
+                class_type = 'fa fa-file-text tbl_file';
+              }
 
-            var file_name_original = encodeURI((data[key]).Filename);
-            result += '<tr class="' + cap_classes + '">';
+              var file_name_original = encodeURI((data[key]).Filename);
+              result += '<tr class="' + cap_classes + '">';
 
-            var fm_filename = (data[key]).Filename;
-            if (fm_filename.length > 48) {
-              fm_filename = (data[key]).Filename.substr(0, 48) +'...';
-            }
+              var fm_filename = (data[key]).Filename;
+              if (fm_filename.length > 48) {
+                fm_filename = (data[key]).Filename.substr(0, 48) + '...';
+              }
 
-            result += '<td title="' + path + '" class="'+class_type+'">';
-            if ((data[key]).Protected == 1) {
-              result +=
-                '<i class="fa fa-lock tbl_lock_icon" data-protected="protected"></i>';
-            }
-            if (!has_capability(data[key], 'rename')) {
-              result += '<span title="' + (data[key]).Filename + '">' +
-                fm_filename + '</span></td>';
-            } else {
-              result += '<p><input type="text" class="fm_file_rename"/><span class="less_text" title="' +
-                file_name_original + '">' + fm_filename + '</span></p></td>';
-            }
-            if (props.Size && props.Size != '') {
-              result += '<td><span title="' + props.Size + '">' +
-                props.Size + '</span></td>';
-            } else {
-              result += '<td></td>';
-            }
+              result += '<td title="' + path + '" class="' + class_type + '">';
+              if ((data[key]).Protected == 1) {
+                result +=
+                  '<i class="fa fa-lock tbl_lock_icon" data-protected="protected"></i>';
+              }
+              if (!has_capability(data[key], 'rename')) {
+                result += '<span title="' + (data[key]).Filename + '">' +
+                  fm_filename + '</span></td>';
+              } else {
+                result += '<p><input type="text" class="fm_file_rename"/><span class="less_text" title="' +
+                  file_name_original + '">' + fm_filename + '</span></p></td>';
+              }
+              if (props.Size && props.Size != '') {
+                result += '<td><span title="' + props.Size + '">' +
+                  props.Size + '</span></td>';
+              } else {
+                result += '<td></td>';
+              }
 
-            if (props['Date Modified'] && props['Date Modified'] != '') {
-              result += '<td>' + props['Date Modified'] + '</td>';
-            } else {
-              result += '<td></td>';
-            }
+              if (props['Date Modified'] && props['Date Modified'] != '') {
+                result += '<td>' + props['Date Modified'] + '</td>';
+              } else {
+                result += '<td></td>';
+              }
 
-            result += '</tr>';
-          });
+              result += '</tr>';
+            });
 
-          result += '</tbody>';
-          result += '</table>';
-        }
-      } else {
-        if ($('.fileinfo').data('view') == 'grid') {
-          result += '<ul id="contents" class="grid"></ul>';
+            result += '</tbody>';
+            result += '</table>';
+          }
         } else {
-          result += '<table id="contents" class="list">';
-          result += '<thead><tr><th class="headerSortDown"><span>' +
-            lg.name + '</span></th><th><span>' + lg.size +
+          if ($('.fileinfo').data('view') == 'grid') {
+            result += '<ul id="contents" class="grid"></ul>';
+          } else {
+            result += '<table id="contents" class="list">';
+            result += '<thead><tr><th class="headerSortDown"><span>' +
+              lg.name + '</span></th><th><span>' + lg.size +
               '</span></th><th><span>' + lg.modified +
               '</span></th></tr></thead>';
-          result += '<tbody>';
-        }
-        result += '<h1 class="no_folder_found">' +
-          lg.could_not_retrieve_folder + '</h1>';
+            result += '<tbody>';
+          }
+          result += '<h1 class="no_folder_found">' +
+            lg.could_not_retrieve_folder + '</h1>';
 
-        var cap_no_folders = ['upload', 'create'];
+          var cap_no_folders = ['upload', 'create'];
 
-        data.Capabilities = cap_no_folders;
-        bindToolbar(data);
-      }
-
-      // Add the new markup to the DOM.
-      $('.fileinfo .file_listing').html(result);
+          data.Capabilities = cap_no_folders;
+          bindToolbar(data);
+        }
 
-      // rename file/folder
-      $('.file_manager button.rename').unbind().on('click',function(e) {
-        if ($('.fileinfo').data('view') == 'grid') {
-          e.stopPropagation();
-          var $this = $('.file_manager').find('#contents li.selected p'),
-              orig_value = decodeURI($this.find('span').attr('title')),
-              newvalue = orig_value.substring(0, orig_value.indexOf('.'));
+        // Add the new markup to the DOM.
+        $('.fileinfo .file_listing').html(result);
 
-          if (newvalue === '') {
-            newvalue = decodeURI(orig_value);
-          }
+        // rename file/folder
+        $('.file_manager button.rename').unbind().on('click', function(e) {
 
-          $this.find('input').toggle().val(newvalue).focus();
-          $this.find('span').toggle();
+          if ($('.fileinfo').data('view') == 'grid') {
+            e.stopPropagation();
+            $this = $('.file_manager').find('#contents li.selected p');
+            orig_value = decodeURI($this.find('span').attr('title'));
+            newvalue = orig_value.substring(0, orig_value.indexOf('.'));
 
-          // Rename folder/file on pressing enter key
-          $('.file_manager').unbind().on('keyup', function(e) {
-            if (e.keyCode == 13) {
-              e.stopPropagation();
-              $('.fileinfo #contents li.selected p').find(
-                'input'
-              ).trigger('blur');
+            if (newvalue === '') {
+              newvalue = decodeURI(orig_value);
             }
-          });
-        } else if ($('.fileinfo').data('view') == 'list') {
-          e.stopPropagation();
-          var $this = $('.fileinfo').find(
-                'table#contents tbody tr.selected td:first-child p'
-              ),
-              orig_value = decodeURI($this.find('span').html()),
-              newvalue = orig_value.substring(0, orig_value.lastIndexOf('.'));
 
-          if (orig_value.lastIndexOf('/') == orig_value.length - 1 || newvalue === '') {
-            newvalue = decodeURI(orig_value);
-          }
+            $this.find('input').toggle().val(newvalue).focus();
+            $this.find('span').toggle();
 
-          $this.find('input').toggle().val(newvalue).focus();
-          $this.find('span').toggle();
+            // Rename folder/file on pressing enter key
+            $('.file_manager').unbind().on('keyup', function(e) {
+              if (e.keyCode == 13) {
+                e.stopPropagation();
+                $('.fileinfo #contents li.selected p').find(
+                  'input'
+                ).trigger('blur');
+              }
+            });
+          } else if ($('.fileinfo').data('view') == 'list') {
+            e.stopPropagation();
+            $this = $('.fileinfo').find(
+              'table#contents tbody tr.selected td:first-child p'
+            );
+            orig_value = decodeURI($this.find('span').html()),
+              newvalue = orig_value.substring(0, orig_value.lastIndexOf('.'));
 
-          // Rename folder/file on pressing enter key
-          $('.file_manager').unbind().on('keyup', function(e) {
-            if (e.keyCode == 13) {
-              e.stopPropagation();
-              $('.fileinfo table#contents tr.selected td p').find(
-                'input'
-              ).trigger('blur');
+            if (orig_value.lastIndexOf('/') == orig_value.length - 1 || newvalue === '') {
+              newvalue = decodeURI(orig_value);
             }
-          });
-        }
-      });
 
-      // Rename UI handling
-      $('.fileinfo #contents li p').on('blur dblclick','input', function(e) {
-        e.stopPropagation();
+            $this.find('input').toggle().val(newvalue).focus();
+            $this.find('span').toggle();
 
-        var old_name = decodeURI($(this).siblings('span').attr('title')),
-            newvalue = old_name.substring(0, old_name.indexOf('.')),
-            last = getFileExtension(old_name);
+            // Rename folder/file on pressing enter key
+            $('.file_manager').unbind().on('keyup', function(e) {
+              if (e.keyCode == 13) {
+                e.stopPropagation();
+                $('.fileinfo table#contents tr.selected td p').find(
+                  'input'
+                ).trigger('blur');
+              }
+            });
+          }
+        });
 
-        if (old_name.indexOf('.') == 0) {
-          last = '';
-        }
+        // Rename UI handling
+        $('.fileinfo #contents li p').on('blur dblclick', 'input', function(e) {
+          e.stopPropagation();
 
-        if (newvalue == '') {
-          newvalue = decodeURI(old_name);
-        }
+          var old_name = decodeURI($(this).siblings('span').attr('title'));
+          newvalue = old_name.substring(0, old_name.indexOf('.'));
+          var last = getFileExtension(old_name),
+            data, new_name, path, full_name;
 
-        if (e.type=="keydown") {
-          if (e.which==13) {
-            var full_name = decodeURI($(this).val()) + (
-              last !== '' ? '.' + last: ''
-            );
+          if (old_name.indexOf('.') == 0) {
+            last = '';
+          }
 
-            $(this).toggle();
-            $(this).siblings('span').toggle().html(full_name);
-
-            var new_name = decodeURI($(this).val()),
-                path = decodeURI($(this).parent().parent().find(
-                  'span'
-                ).attr('data-alt')),
-                data = {
-                  'Filename': old_name,
-                  'Path': path,
-                  'NewFilename': new_name
-                };
-
-            if (newvalue !== new_name) {
-              renameItem(data);
-              var parent = $('.currentpath').val();
-              getFolderInfo(parent);
-            }
-            e.stopPropagation();
+          if (newvalue == '') {
+            newvalue = decodeURI(old_name);
           }
 
-          if (
-            e.which==38 || e.which==40 || e.which==37 ||
-            e.which==39 || e.keyCode == 32
-          ) {
+          if (e.type == 'keydown') {
+            if (e.which == 13) {
+              full_name = decodeURI($(this).val()) + (
+                last !== '' ? '.' + last : ''
+              );
+
+              $(this).toggle();
+              $(this).siblings('span').toggle().html(full_name);
+
+              new_name = decodeURI($(this).val());
+              path = decodeURI($(this).parent().parent().find(
+                'span'
+              ).attr('data-alt'));
+              data = {
+                'Filename': old_name,
+                'Path': path,
+                'NewFilename': new_name,
+              };
+
+              if (newvalue !== new_name) {
+                renameItem(data);
+                var parent = $('.currentpath').val();
+                getFolderInfo(parent);
+              }
               e.stopPropagation();
-          }
-        } else if (e.type=="focusout") {
-          if ($(this).css('display')=="inline-block" || $(this).css('display')=="inline") {
-            var full_name = decodeURI(
-                  $(this).val()
-                ) + (last !== ''? '.' + last: '');
-
-            $(this).toggle();
-            $(this).siblings('span').toggle().html(full_name);
-
-            var new_name = decodeURI($(this).val()),
-                path = decodeURI($(this).parent().parent().find(
-                  'span'
-                ).attr('data-alt')),
-                data = {
-                  'Filename': old_name,
-                  'Path': path,
-                  'NewFilename': new_name
-                };
-
-            if (newvalue !== new_name) {
-              renameItem(data);
-              getFolderInfo($('.currentpath').val());
             }
-          }
-        } else {
-          e.stopPropagation();
-        }
-      });
 
-      $('.fileinfo table#contents tr td p').on(
-        'blur dblclick', 'input', function(e) {
-        var old_name = decodeURI($(this).siblings('span').attr('title')),
-            newvalue = old_name.substring(0, old_name.indexOf('.')),
-            last = getFileExtension(old_name);
-        if (old_name.indexOf('.') == 0) {
-          last = '';
-        }
+            if (
+              e.which == 38 || e.which == 40 || e.which == 37 ||
+              e.which == 39 || e.keyCode == 32
+            ) {
+              e.stopPropagation();
+            }
+          } else if (e.type == 'focusout') {
+            if ($(this).css('display') == 'inline-block' || $(this).css('display') == 'inline') {
+              full_name = decodeURI(
+                $(this).val()
+              ) + (last !== '' ? '.' + last : '');
+
+              $(this).toggle();
+              $(this).siblings('span').toggle().html(full_name);
+
+              new_name = decodeURI($(this).val());
+              path = decodeURI($(this).parent().parent().find(
+                'span'
+              ).attr('data-alt'));
+              data = {
+                'Filename': old_name,
+                'Path': path,
+                'NewFilename': new_name,
+              };
+
+              if (newvalue !== new_name) {
+                renameItem(data);
+                getFolderInfo($('.currentpath').val());
+              }
+            }
+          } else {
+            e.stopPropagation();
+          }
+        });
 
-        if (newvalue == '') {
-          newvalue = old_name;
-        }
+        $('.fileinfo table#contents tr td p').on(
+          'blur dblclick', 'input',
+          function(e) {
+            var old_name = decodeURI($(this).siblings('span').attr('title')),
+              newvalue = old_name.substring(0, old_name.indexOf('.')),
+              last = getFileExtension(old_name);
+            if (old_name.indexOf('.') == 0) {
+              last = '';
+            }
 
-        if (e.type=="focusout") {
-          if ($(this).css('display')=="inline-block" || $(this).css('display')=="inline") {
-            var full_name = decodeURI($(this).val()) + (
-              last !== ''? '.' + last: ''
-            );
-            $(this).toggle();
-            $(this).siblings('span').toggle().html(full_name);
-
-            var new_name = decodeURI($(this).val()),
-                path = decodeURI($(this).parent().parent().attr('title')),
-                data = {
-                  'Filename': old_name,
-                  'Path': path,
-                  'NewFilename': new_name
-                };
-
-            if (newvalue !== new_name) {
-              renameItem(data);
-              var parent = path.split('/').reverse().slice(2).reverse().join('/') + '/';
-              getFolderInfo(parent);
+            if (newvalue == '') {
+              newvalue = old_name;
             }
-          }
-        } else {
-          e.stopPropagation();
-        }
-      });
 
-      var data_cap = {};
-      data_cap.Capabilities = capabilities;
-      /*
-       * Bind click events
-       * Select items - afolder dblclick
-       */
-      if ($('.fileinfo').data('view') == 'grid') {
-        // Get into folder on dblclick
-        $('.fileinfo').find('#contents li').dblclick(function(e) {
-          e.stopPropagation();
-          // Enable/Disable level up button
-          enab_dis_level_up();
+            if (e.type == 'focusout') {
+              if ($(this).css('display') == 'inline-block' || $(this).css('display') == 'inline') {
+                var full_name = decodeURI($(this).val()) + (
+                  last !== '' ? '.' + last : ''
+                );
+                $(this).toggle();
+                $(this).siblings('span').toggle().html(full_name);
+
+                var new_name = decodeURI($(this).val()),
+                  path = decodeURI($(this).parent().parent().attr('title')),
+                  data = {
+                    'Filename': old_name,
+                    'Path': path,
+                    'NewFilename': new_name,
+                  };
+
+                if (newvalue !== new_name) {
+                  renameItem(data);
+                  var parent = path.split('/').reverse().slice(2).reverse().join('/') + '/';
+                  getFolderInfo(parent);
+                }
+              }
+            } else {
+              e.stopPropagation();
+            }
+          });
+
+        var data_cap = {};
+        data_cap.Capabilities = capabilities;
+        /*
+         * Bind click events
+         * Select items - afolder dblclick
+         */
+        if ($('.fileinfo').data('view') == 'grid') {
+          // Get into folder on dblclick
+          $('.fileinfo').find('#contents li').dblclick(function(e) {
+            e.stopPropagation();
+            // Enable/Disable level up button
+            enab_dis_level_up();
 
-          var path = decodeURI($(this).find('span').attr('data-alt'));
+            var path = decodeURI($(this).find('span').attr('data-alt'));
 
-          if (path.lastIndexOf("/") == path.length - 1 || path.lastIndexOf("\\") == path.length - 1) {
-            $('.file_manager_ok').addClass('disabled');
-            $('.file_manager_ok').attr('disabled', true);
-            $('.file_manager button.delete, .file_manager button.rename').attr('disabled', 'disabled');
-            $('.file_manager button.download').attr('disabled', 'disabled');
+            if (path.lastIndexOf('/') == path.length - 1 || path.lastIndexOf('\\') == path.length - 1) {
+              $('.file_manager_ok').addClass('disabled');
+              $('.file_manager_ok').attr('disabled', true);
+              $('.file_manager button.delete, .file_manager button.rename').attr('disabled', 'disabled');
+              $('.file_manager button.download').attr('disabled', 'disabled');
 
-            getFolderInfo(path);
+              getFolderInfo(path);
 
-          } else {
-            var is_valid_file = getFileInfo(path);
-            if (is_valid_file && check_file_capability(e, data_cap, 'grid')) {
-              $('.file_manager_ok').click();
+            } else {
+              var is_valid_file = getFileInfo(path);
+              if (is_valid_file && check_file_capability(e, data_cap, 'grid')) {
+                $('.file_manager_ok').click();
+              }
             }
-          }
-        });
+          });
 
-        $('.fileinfo').find('#contents li').click(function(e) {
-          e.stopPropagation();
-          var path = decodeURI($(this).find('.clip span').attr('data-alt')),
-              file_name = $(this).find('p span').attr('title'),
+          $('.fileinfo').find('#contents li').click(function(e) {
+            e.stopPropagation();
+            var path = decodeURI($(this).find('.clip span').attr('data-alt')),
               is_protected = $(this).find(
                 '.clip span.fm_lock_icon'
               ).attr('data-protected');
 
-          if (path.lastIndexOf('/') == path.length - 1 || path.lastIndexOf('\\') == path.length - 1) {
-            if (
-              has_capability(data_cap, 'select_folder') &&
-              is_protected == undefined
-            ) {
-              $(this).parent().find('li.selected').removeClass('selected');
-              $(this).addClass('selected');
+            if (path.lastIndexOf('/') == path.length - 1 || path.lastIndexOf('\\') == path.length - 1) {
+              if (
+                has_capability(data_cap, 'select_folder') &&
+                is_protected == undefined
+              ) {
+                $(this).parent().find('li.selected').removeClass('selected');
+                $(this).addClass('selected');
+
+                $('.file_manager_ok').removeClass('disabled');
+                $('.file_manager_ok').attr('disabled', false);
+                $('.file_manager button.delete, .file_manager button.rename').removeAttr(
+                  'disabled', 'disabled'
+                );
+                $('.file_manager button.download').attr(
+                  'disabled', 'disabled'
+                );
+                // set selected folder name in breadcrums
+                $('.file_manager #uploader .input-path').hide();
+                $('.file_manager #uploader .show_selected_file').remove();
+                $('<span class="show_selected_file">' + path + '</span>').appendTo(
+                  '.file_manager #uploader .filemanager-path-group'
+                );
+              }
+            } else {
+              if (
+                has_capability(data_cap, 'select_file') &&
+                is_protected == undefined
+              ) {
+                $(this).parent().find('li.selected').removeClass('selected');
+                $(this).addClass('selected');
+                $('.file_manager_ok').removeClass('disabled');
+                $('.file_manager_ok').attr('disabled', false);
+                $('.file_manager button.delete, .file_manager button.download, .file_manager button.rename').removeAttr(
+                  'disabled'
+                );
+                // set selected folder name in breadcrums
+                $('.file_manager #uploader .show_selected_file').remove();
+              }
 
-              $('.file_manager_ok').removeClass('disabled');
-              $('.file_manager_ok').attr('disabled', false);
-              $('.file_manager button.delete, .file_manager button.rename').removeAttr(
-                'disabled', 'disabled'
-              );
-              $('.file_manager button.download').attr(
-                'disabled', 'disabled'
-              );
-              // set selected folder name in breadcrums
-              $('.file_manager #uploader .input-path').hide();
-              $('.file_manager #uploader .show_selected_file').remove();
-              $('<span class="show_selected_file">'+path+'</span>').appendTo(
-                '.file_manager #uploader .filemanager-path-group'
-              );
-            }
-          } else {
-            if (
-              has_capability(data_cap, 'select_file') &&
-              is_protected == undefined
-            ) {
-              $(this).parent().find('li.selected').removeClass('selected');
-              $(this).addClass('selected');
-              $('.file_manager_ok').removeClass('disabled');
-              $('.file_manager_ok').attr('disabled', false);
-              $('.file_manager button.delete, .file_manager button.download, .file_manager button.rename').removeAttr(
-                'disabled'
-              );
-              // set selected folder name in breadcrums
-              $('.file_manager #uploader .show_selected_file').remove();
+              getFileInfo(path);
             }
-
-            getFileInfo(path);
-          }
-        });
-      } else {
-        $('.fileinfo table#contents tbody tr').on('click', function(e) {
-          e.stopPropagation();
-          var path = decodeURI($('td:first-child', this).attr('title')),
-              file_name = decodeURI($('td:first-child p span', this).attr(
-                'title'
-              )),
+          });
+        } else {
+          $('.fileinfo table#contents tbody tr').on('click', function(e) {
+            e.stopPropagation();
+            var path = decodeURI($('td:first-child', this).attr('title')),
               is_protected = $('td:first-child', this).find(
                 'i.tbl_lock_icon'
               ).attr('data-protected');
 
-          if (path.lastIndexOf('/') == path.length - 1 || path.lastIndexOf('\\') == path.length - 1) {
-            if (has_capability(data_cap, 'select_folder') && is_protected == undefined) {
-              $(this).parent().find('tr.selected').removeClass('selected');
-              $('td:first-child', this).parent().addClass('selected');
-              $('.file_manager_ok').removeClass('disabled');
-              $('.file_manager_ok').attr('disabled', false);
-              $('.file_manager button.download').attr('disabled', 'disabled');
-              $('.file_manager button.delete, .file_manager button.rename').removeAttr('disabled');
+            if (path.lastIndexOf('/') == path.length - 1 || path.lastIndexOf('\\') == path.length - 1) {
+              if (has_capability(data_cap, 'select_folder') && is_protected == undefined) {
+                $(this).parent().find('tr.selected').removeClass('selected');
+                $('td:first-child', this).parent().addClass('selected');
+                $('.file_manager_ok').removeClass('disabled');
+                $('.file_manager_ok').attr('disabled', false);
+                $('.file_manager button.download').attr('disabled', 'disabled');
+                $('.file_manager button.delete, .file_manager button.rename').removeAttr('disabled');
+
+                // set selected folder name in breadcrums
+                $('.file_manager #uploader .input-path').hide();
+                $('.file_manager #uploader .show_selected_file').remove();
+                $('<span class="show_selected_file">' + path + '</span>').appendTo(
+                  '.file_manager #uploader .filemanager-path-group'
+                );
+              }
+            } else {
+              if (has_capability(data_cap, 'select_file') && is_protected == undefined) {
+                $(this).parent().find('tr.selected').removeClass('selected');
+                $('td:first-child', this).parent().addClass('selected');
+                $('.file_manager button.delete, .file_manager button.download, .file_manager button.rename').removeAttr(
+                  'disabled'
+                );
+                // set selected folder name in breadcrums
+                $('.file_manager #uploader .show_selected_file').remove();
+              }
 
-              // set selected folder name in breadcrums
-              $('.file_manager #uploader .input-path').hide();
-              $('.file_manager #uploader .show_selected_file').remove();
-              $('<span class="show_selected_file">'+path+'</span>').appendTo(
-                '.file_manager #uploader .filemanager-path-group'
-              );
+              getFileInfo(path);
             }
-          } else {
-            if (has_capability(data_cap, 'select_file') && is_protected == undefined) {
-              $(this).parent().find('tr.selected').removeClass('selected');
-              $('td:first-child', this).parent().addClass('selected');
-              $('.file_manager button.delete, .file_manager button.download, .file_manager button.rename').removeAttr(
-                'disabled'
-              );
-              // set selected folder name in breadcrums
-              $('.file_manager #uploader .show_selected_file').remove();
-            }
-
-            getFileInfo(path);
-          }
-        });
+          });
 
-        $('.fileinfo table#contents tbody tr').on('dblclick', function(e) {
-          e.stopPropagation();
-          // Enable/Disable level up button
-          enab_dis_level_up();
-          var path = $('td:first-child', this).attr('title');
+          $('.fileinfo table#contents tbody tr').on('dblclick', function(e) {
+            e.stopPropagation();
+            // Enable/Disable level up button
+            enab_dis_level_up();
+            var path = $('td:first-child', this).attr('title');
 
-          if (path.lastIndexOf('/') == path.length - 1 || path.lastIndexOf('\\') == path.length - 1) {
-            $('.file_manager_ok').addClass('disabled');
-            $('.file_manager_ok').attr('disabled', true);
-            $('.file_manager button.download').attr('disabled', 'disabled');
-            $('.file_manager button.delete, .file_manager button.rename').attr('disabled', 'disabled');
-            getFolderInfo(path);
-          } else {
-            var is_valid_file = getFileInfo(path), is_protected;
-            if (is_valid_file && check_file_capability(e, data_cap, 'table')) {
-              $('.file_manager_ok').click();
+            if (path.lastIndexOf('/') == path.length - 1 || path.lastIndexOf('\\') == path.length - 1) {
+              $('.file_manager_ok').addClass('disabled');
+              $('.file_manager_ok').attr('disabled', true);
+              $('.file_manager button.download').attr('disabled', 'disabled');
+              $('.file_manager button.delete, .file_manager button.rename').attr('disabled', 'disabled');
+              getFolderInfo(path);
+            } else {
+              var is_valid_file = getFileInfo(path);
+              if (
+                is_valid_file && check_file_capability(e, data_cap, 'table')
+              ) {
+                $('.file_manager_ok').click();
+              }
             }
-          }
-        });
+          });
 
-      }
-      //input_object.set_cap(data_cap);
-    },
-    error: function() {
-      $('.storage_dialog #uploader .input-path').prop('disabled', false);
-    }
-  });
-};
+        }
+        //input_object.set_cap(data_cap);
+      },
+      error: function() {
+        $('.storage_dialog #uploader .input-path').prop('disabled', false);
+      },
+    });
+  };
 
-// Enable/Disable level up button
-var enab_dis_level_up = function() {
-  $('.file_manager #uploader .input-path').show();
-  $('.show_selected_file').remove();
+  // Enable/Disable level up button
+  var enab_dis_level_up = function() {
+    $('.file_manager #uploader .input-path').show();
+    $('.show_selected_file').remove();
 
-  setTimeout(function() {
-    var b = $('.currentpath').val(),
+    setTimeout(function() {
+      var b = $('.currentpath').val(),
         $level_up = $('.file_manager').find('button.level-up'),
         $home_btn = $('.file_manager').find('button.home');
 
-    if (b === '/') {
-      $level_up.attr('disabled', 'disabled');
-      $home_btn.attr('disabled', 'disabled');
+      if (b === '/') {
+        $level_up.attr('disabled', 'disabled');
+        $home_btn.attr('disabled', 'disabled');
+      } else {
+        $home_btn.removeAttr('disabled');
+        $level_up.removeAttr('disabled');
+      }
+    }, 100);
+  };
+
+  // Check if user can Select file
+  var check_file_capability = function(event, data_cap, view_type) {
+    var current_element = event.currentTarget,
+      is_protected;
+
+    if (view_type == 'grid') {
+      is_protected = $(current_element).find(
+        '.clip span.fm_lock_icon'
+      ).attr('data-protected');
     } else {
-      $home_btn.removeAttr('disabled');
-      $level_up.removeAttr('disabled');
+      is_protected = $(current_element).find('td:first-child').find(
+        'i.tbl_lock_icon'
+      ).attr('data-protected');
     }
-  }, 100);
-};
-
-// Check if user can Select file
-var check_file_capability = function(event, data_cap, view_type) {
-  var current_element = event.currentTarget,
-      path, file_name, is_protected;
-
-  if (view_type == 'grid') {
-    path = decodeURI($(current_element).find('.clip span').attr('data-alt')),
-    file_name = $(current_element).find('p span').attr('title'),
-    is_protected = $(current_element).find(
-      '.clip span.fm_lock_icon'
-    ).attr('data-protected');
-  } else {
-    path = decodeURI($(current_element).find('td:first-child').attr('title')),
-    file_name = decodeURI($(current_element).find('td:first-child p span').attr(
-      'title'
-    )),
-    is_protected = $(current_element).find('td:first-child').find(
-      'i.tbl_lock_icon'
-    ).attr('data-protected');
-  }
-
-  return has_capability(data_cap, 'select_file') && is_protected == undefined;
-}
-
-/*---------------------------------------------------------
-  Initialization - Entry point
----------------------------------------------------------*/
-/*
- * get transaction id to generate request url and
- * to generate config files on runtime
- */
-pgAdmin.FileUtils = {
-  init: function() {
-    var fm_url = url_for('file_manager.get_trans_id'),
+
+    return has_capability(data_cap, 'select_file') &&
+      is_protected == undefined;
+  };
+
+  /*---------------------------------------------------------
+    Initialization - Entry point
+  ---------------------------------------------------------*/
+  /*
+   * get transaction id to generate request url and
+   * to generate config files on runtime
+   */
+  pgAdmin.FileUtils = {
+    init: function() {
+      var fm_url = url_for('file_manager.get_trans_id'),
         transId = loadData(fm_url),
         t_res,
         t_id;
 
-    if (transId.readyState == 4) {
-      t_res = JSON.parse(transId.responseText);
-    }
-    t_id = t_res.data.fileTransId;
-    var root_url = url_for("file_manager.index"),
-        file_manager_config_json = root_url+t_id+'/file_manager_config.json',
-        file_manager_config_js = root_url+'file_manager_config.js',
-        fileConnector = root_url+'filemanager/'+t_id+'/',
+      if (transId.readyState == 4) {
+        t_res = JSON.parse(transId.responseText);
+      }
+      t_id = t_res.data.fileTransId;
+      var root_url = url_for('file_manager.index'),
+        file_manager_config_json = root_url + t_id + '/file_manager_config.json',
+        fileConnector = root_url + 'filemanager/' + t_id + '/',
         cfg = loadData(file_manager_config_json),
         config;
 
-    this.fileConnector = fileConnector;
-    this.transId = t_id;
-    // load user configuration file
-    if (cfg.readyState == 4) {
-      this.config = config = JSON.parse(cfg.responseText);
-    }
+      this.fileConnector = fileConnector;
+      this.transId = t_id;
+      // load user configuration file
+      if (cfg.readyState == 4) {
+        this.config = config = JSON.parse(cfg.responseText);
+      }
 
-    // set main url to filemanager and its capabilites
-    var fileRoot = config.options.fileRoot,
+      // set main url to filemanager and its capabilites
+      var fileRoot = config.options.fileRoot,
         capabilities = config.options.capabilities;
 
-    /*
-     * Get localized messages from file
-     * through culture var or from URL
-     */
+      /*
+       * Get localized messages from file
+       * through culture var or from URL
+       */
 
-    var lg = [],
-        enjs = url_for("file_manager.index") + "en.js",
+      var lg = [],
+        enjs = url_for('file_manager.index') + 'en.js',
         lgf = loadData(enjs);
 
-    if (lgf.readyState == 4) {
-      this.lg = lg = JSON.parse(lgf.responseText);
-    }
+      if (lgf.readyState == 4) {
+        this.lg = lg = JSON.parse(lgf.responseText);
+      }
 
-    // create and enable user to create new file
-    if (
-      config.options.dialog_type == 'select_file' ||
-      config.options.dialog_type == 'create_file' ||
-      config.options.dialog_type == 'storage_dialog'
-    ) {
-      // Create file selection dropdown
-      var allowed_types = config.options.allowed_file_types,
+      // create and enable user to create new file
+      if (
+        config.options.dialog_type == 'select_file' ||
+        config.options.dialog_type == 'create_file' ||
+        config.options.dialog_type == 'storage_dialog'
+      ) {
+        // Create file selection dropdown
+        var allowed_types = config.options.allowed_file_types,
           types_len = allowed_types.length,
-          select_box = '',
-          file_type = '';
+          select_box = '';
 
-      if (types_len > 0) {
-        var i = 0, j = 0, t,
+        if (types_len > 0) {
+          var i = 0,
+            t,
             selected = false,
             have_all_types = false;
 
-        var select_box = "<div class='change_file_types'>" +
-          gettext("Show hidden files and folders") +
-          "? <input type='checkbox' id='show_hidden' onclick='pgAdmin.FileUtils.handleClick(this)' tabindex='11'>" +
-          "<span></span>" +
-          "<select name='type' tabindex='12'>";
-
-        while(i < types_len) {
-          t = allowed_types[i];
-          if (!selected && (types_len == 1 || t != '*')) {
-            select_box += "<option value=" + t + " selected>" + t + "</option>";
-            selected = true;
-            have_all_types = (have_all_types || (t == '*'));
-          } else {
-            select_box += '<option value="' + t +'">' +
-              (t == '*' ? gettext('All Files') : t) + "</option>";
-            have_all_types = (have_all_types || (t == '*'));
+          select_box = '<div class=\'change_file_types\'>' +
+            gettext('Show hidden files and folders') +
+            '? <input type=\'checkbox\' id=\'show_hidden\' onclick=\'pgAdmin.FileUtils.handleClick(this)\' tabindex=\'11\'>' +
+            '<span></span>' +
+            '<select name=\'type\' tabindex=\'12\'>';
+
+          while (i < types_len) {
+            t = allowed_types[i];
+            if (!selected && (types_len == 1 || t != '*')) {
+              select_box += '<option value=' + t + ' selected>' + t + '</option>';
+              selected = true;
+              have_all_types = (have_all_types || (t == '*'));
+            } else {
+              select_box += '<option value="' + t + '">' +
+                (t == '*' ? gettext('All Files') : t) + '</option>';
+              have_all_types = (have_all_types || (t == '*'));
+            }
+            i++;
           }
-          i++;
-        }
 
-        if (!have_all_types) {
-          select_box += '<option value="*">' + gettext('All Files') + '</option>';
+          if (!have_all_types) {
+            select_box += '<option value="*">' + gettext('All Files') + '</option>';
+          }
+          select_box += '</select><label>' + gettext('Format') + ': </label></div>';
         }
-        select_box += "</select><label>" + gettext('Format') + ": </label></div>";
-      }
 
-      $(".allowed_file_types").html(select_box);
+        $('.allowed_file_types').html(select_box);
 
-      $(".allowed_file_types select").on('change', function() {
-        var selected_val = $(this).val(),
+        $('.allowed_file_types select').on('change', function() {
+          var selected_val = $(this).val(),
             curr_path = $('.currentpath').val();
-        getFolderInfo(curr_path, selected_val);
-      });
-
-      // If user have preference to show hidden files
-      if (config.options.show_hidden_files) {
-        setTimeout(function() {
-          $("#show_hidden").click();
-        }, 10);
-      }
-      // handle show hidden files functionality
-      this.handleClick = function(cb) {
-        var data = {
-          'is_checked': false
-        };
+          getFolderInfo(curr_path, selected_val);
+        });
 
-        if(cb.checked) {
-          $("div.allowed_file_types select").val("*").trigger("change");
-          data['is_checked'] = true;
-        } else {
-          // User wants to hide it again
-          $("div.allowed_file_types select").prop('selectedIndex', 0).trigger("change");
-          data['is_checked'] = false;
+        // If user have preference to show hidden files
+        if (config.options.show_hidden_files) {
+          setTimeout(function() {
+            $('#show_hidden').click();
+          }, 10);
         }
-        // Save it in preference
-        save_show_hidden_file_option(data['is_checked'], pgAdmin.FileUtils.transId);
-        return;
+        // handle show hidden files functionality
+        this.handleClick = function(cb) {
+          var data = {
+            'is_checked': false,
+          };
+
+          if (cb.checked) {
+            $('div.allowed_file_types select').val('*').trigger('change');
+            data['is_checked'] = true;
+          } else {
+            // User wants to hide it again
+            $('div.allowed_file_types select').prop('selectedIndex', 0).trigger('change');
+            data['is_checked'] = false;
+          }
+          // Save it in preference
+          save_show_hidden_file_option(data['is_checked'], pgAdmin.FileUtils.transId);
+          return;
+        };
       }
-    }
 
-    /*---------------------------------------------------------
-      Item Actions - Object events
-    ---------------------------------------------------------*/
+      /*---------------------------------------------------------
+        Item Actions - Object events
+      ---------------------------------------------------------*/
 
-    // switch to folder view
-    $('.file_manager .fileinfo').on('click', function(e) {
-      $('.file_manager #uploader .input-path').val($('.currentpath').val())
-      enable_disable_btn();
-    });
+      // Switch to folder view
+      $('.file_manager .fileinfo').on('click', function() {
+        $('.file_manager #uploader .input-path').val($('.currentpath').val());
+        enable_disable_btn();
+      });
+
+      // Refresh current directory
+      $('.file_manager .refresh').on('click', function() {
+        enable_disable_btn();
+
+        var curr_path = $('.currentpath').val(),
+          path;
 
-    // refresh current directory
-    $('.file_manager .refresh').on('click', function(e) {
-      enable_disable_btn();
-      var curr_path = $('.currentpath').val();
         $('.file_manager #uploader .input-path').val(curr_path);
-        if(curr_path.endsWith("/")) {
-            var path = curr_path.substring(0, curr_path.lastIndexOf("/")) + "/";
+        if (curr_path.endsWith('/')) {
+          path = curr_path.substring(0, curr_path.lastIndexOf('/')) + '/';
         } else {
-            var path = curr_path.substring(0, curr_path.lastIndexOf("\\")) + "\\";
+          path = curr_path.substring(0, curr_path.lastIndexOf('\\')) + '\\';
         }
-      getFolderInfo(path);
-    });
+        getFolderInfo(path);
+      });
 
-    // hide message prompt and dimmer if clicked no
-    $('.delete_item button.btn_no').on('click', function() {
-      $('.delete_item, .fileinfo .fm_dimmer').hide();
-    });
+      // hide message prompt and dimmer if clicked no
+      $('.delete_item button.btn_no').on('click', function() {
+        $('.delete_item, .fileinfo .fm_dimmer').hide();
+      });
 
-    // Disable home button on load
-    $('.file_manager').find('button.home').attr('disabled', 'disabled');
-    $('.file_manager').find('button.rename').attr('disabled', 'disabled');
+      // Disable home button on load
+      $('.file_manager').find('button.home').attr('disabled', 'disabled');
+      $('.file_manager').find('button.rename').attr('disabled', 'disabled');
 
-    // stop click event on dimmer click
-    $('.fileinfo .fm_dimmer').on('click', function(e) {
-      e.stopPropagation();
-    });
+      // stop click event on dimmer click
+      $('.fileinfo .fm_dimmer').on('click', function(e) {
+        e.stopPropagation();
+      });
 
-    $('.fileinfo .replace_file').not(
-      $(this).find('span.pull-right')
-    ).on(
-    'click', function(e) {
-      $('#uploader .filemanager-btn-group').unbind().on(
-        'click', function() {
-          $('.fileinfo .delete_item, .fileinfo .replace_file, .fileinfo .fm_dimmer').hide();
+      $('.fileinfo .replace_file').not(
+        $(this).find('span.pull-right')
+      ).on(
+        'click',
+        function(e) {
+          $('#uploader .filemanager-btn-group').unbind().on(
+            'click',
+            function() {
+              $('.fileinfo .delete_item, .fileinfo .replace_file, .fileinfo .fm_dimmer').hide();
+            });
+          e.stopPropagation();
         });
-      e.stopPropagation();
-    });
 
-    // Set initial view state.
-    $('.fileinfo').data('view', config.options.defaultViewMode);
-    setViewButtonsFor(config.options.defaultViewMode);
-
-    // Upload click event
-    $('.file_manager .uploader').on('click', 'a', function(e) {
-      e.preventDefault();
-      var b = $('.currentpath').val();
-      var node_val = $(this).next().text();
-      parent = b.substring(0, b.slice(0, -1).lastIndexOf(node_val));
-      getFolderInfo(parent);
-    });
+      // Set initial view state.
+      $('.fileinfo').data('view', config.options.defaultViewMode);
+      setViewButtonsFor(config.options.defaultViewMode);
+
+      // Upload click event
+      $('.file_manager .uploader').on('click', 'a', function(e) {
+        e.preventDefault();
+        var b = $('.currentpath').val(),
+          node_val = $(this).next().text(),
+          parent = b.substring(0, b.slice(0, -1).lastIndexOf(node_val));
+        getFolderInfo(parent);
+      });
 
-    // re-render the home view
-    $('.file_manager .home').click(function() {
-      var currentViewMode = $('.fileinfo').data('view');
-      $('.fileinfo').data('view', currentViewMode);
-      getFolderInfo('/');
-      enab_dis_level_up();
-    });
+      // re-render the home view
+      $('.file_manager .home').click(function() {
+        var currentViewMode = $('.fileinfo').data('view');
+        $('.fileinfo').data('view', currentViewMode);
+        getFolderInfo('/');
+        enab_dis_level_up();
+      });
 
-    // Go one directory back
-    $(".file_manager .level-up").click(function() {
-      var b = $('.currentpath').val();
-      // Enable/Disable level up button
-      enab_dis_level_up();
+      // Go one directory back
+      $('.file_manager .level-up').click(function() {
+        var b = $('.currentpath').val();
+        // Enable/Disable level up button
+        enab_dis_level_up();
 
-      if (b.endsWith('\\') || b.endsWith('/')) {
-        b = b.substring(0, b.length - 1)
-      }
+        if (b.endsWith('\\') || b.endsWith('/')) {
+          b = b.substring(0, b.length - 1);
+        }
 
-      if (b != '/') {
-          if(b.lastIndexOf('/') > b.lastIndexOf('\\')) {
-            var parent = b.substring(0, b.slice(0, -1).lastIndexOf("/")) + "/";
+        if (b != '/') {
+          var parent;
+          if (b.lastIndexOf('/') > b.lastIndexOf('\\')) {
+            parent = b.substring(0, b.slice(0, -1).lastIndexOf('/')) + '/';
           } else {
-            var parent = b.substring(0, b.slice(0, -1).lastIndexOf("\\")) + "\\";
+            parent = b.substring(0, b.slice(0, -1).lastIndexOf('\\')) + '\\';
           }
 
-          var d = $(".fileinfo").data("view");
-          $(".fileinfo").data("view", d);
+          var d = $('.fileinfo').data('view');
+          $('.fileinfo').data('view', d);
           getFolderInfo(parent);
-      }
-    });
+        }
+      });
 
-    // set buttons to switch between grid and list views.
-    $('.file_manager .grid').click(function() {
-      setViewButtonsFor('grid');
-      $('.fileinfo').data('view', 'grid');
-      enable_disable_btn();
-      getFolderInfo($('.currentpath').val());
-      save_file_dialog_view('grid', pgAdmin.FileUtils.transId);
-    });
+      // set buttons to switch between grid and list views.
+      $('.file_manager .grid').click(function() {
+        setViewButtonsFor('grid');
+        $('.fileinfo').data('view', 'grid');
+        enable_disable_btn();
+        getFolderInfo($('.currentpath').val());
+        save_file_dialog_view('grid', pgAdmin.FileUtils.transId);
+      });
 
-    // Show list mode
-    $('.file_manager .list').click(function() {
-      setViewButtonsFor('list');
-      $('.fileinfo').data('view', 'list');
-      enable_disable_btn();
-      getFolderInfo($('.currentpath').val());
-      save_file_dialog_view('list', pgAdmin.FileUtils.transId);
-    });
+      // Show list mode
+      $('.file_manager .list').click(function() {
+        setViewButtonsFor('list');
+        $('.fileinfo').data('view', 'list');
+        enable_disable_btn();
+        getFolderInfo($('.currentpath').val());
+        save_file_dialog_view('list', pgAdmin.FileUtils.transId);
+      });
 
-    // Provide initial values for upload form, status, etc.
-    pgAdmin.FileUtils.setUploader(fileRoot);
+      // Provide initial values for upload form, status, etc.
+      pgAdmin.FileUtils.setUploader(fileRoot);
 
-    var data;
-    this.data = data = {
-      'Capabilities': capabilities
-    };
+      var data;
+      this.data = data = {
+        'Capabilities': capabilities,
+      };
 
-    function InputObject() {
-      this.init= function(cap) {
-        var self = this,
+      function InputObject() {
+        this.init = function(cap) {
+          var self = this,
             check_obj = function(path, check) {
 
-              var path = decodeURI(path);
+              path = decodeURI(path);
               if (path.lastIndexOf('/') == path.length - 1 || path.lastIndexOf('\\') == path.length - 1) {
                 if (
                   has_capability(self.data_cap, 'select_folder')
